## DO NOT EDIT!  Generated automatically from src/libieeep1788_tests_overlap.itl
## by the Interval Testing Framework for IEEE 1788.
## https://github.com/nehmeier/ITF1788/tree/7e5753a2c84051d180748b5dc9896d1a358d742d
##
## Copyright 2013 - 2015 Marco Nehmeier (nehmeier@informatik.uni-wuerzburg.de)
## Copyright 2015 Oliver Heimlich (oheim@posteo.de)
## 
## Original author: Marco Nehmeier (unit tests in libieeep1788)
## Converted into portable ITL format by Oliver Heimlich with minor corrections.
## 
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
## 
##     http://www.apache.org/licenses/LICENSE-2.0
## 
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
%!#Test library imports
%!function s = to_string (x)
%!    if (isnumeric (x))
%!        s = num2str (x);
%!    elseif (isa (x, 'infsup'))
%!        s = intervaltotext (x);
%!    elseif (isa (x, 'intval'))
%!        s = disp_ (x);
%!    else
%!        # x probably is a char.
%!        s = x;
%!    endif
%!endfunction

%!#Arithmetic library imports
%!function n = decval (dec)
%!    n = find (strcmp (dec, {"ill", "trv", "def", "dac", "com"}));
%!endfunction

%!#Preamble

## minimal_overlap_test

%!test
%! assert (all (eq (...
%!    overlap (infsup, infsup), ...
%!    "bothEmpty")))
%!test
%! assert (all (eq (...
%!    overlap (infsup, infsup (1.0, 2.0)), ...
%!    "firstEmpty")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 2.0), infsup), ...
%!    "secondEmpty")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (-inf, 2.0), infsup (3.0, inf)), ...
%!    "before")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (-inf, 2.0), infsup (3.0, 4.0)), ...
%!    "before")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (2.0, 2.0), infsup (3.0, 4.0)), ...
%!    "before")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 2.0), infsup (3.0, 4.0)), ...
%!    "before")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 2.0), infsup (3.0, 3.0)), ...
%!    "before")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (2.0, 2.0), infsup (3.0, 3.0)), ...
%!    "before")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (2.0, 2.0), infsup (3.0, inf)), ...
%!    "before")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (-inf, 2.0), infsup (2.0, 3.0)), ...
%!    "meets")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 2.0), infsup (2.0, 3.0)), ...
%!    "meets")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 2.0), infsup (2.0, inf)), ...
%!    "meets")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 2.0), infsup (1.5, 2.5)), ...
%!    "overlaps")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 2.0), infsup (1.0, inf)), ...
%!    "starts")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 2.0), infsup (1.0, 3.0)), ...
%!    "starts")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 1.0), infsup (1.0, 3.0)), ...
%!    "starts")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 2.0), infsup (-inf, inf)), ...
%!    "containedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 2.0), infsup (-inf, 3.0)), ...
%!    "containedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 2.0), infsup (0.0, 3.0)), ...
%!    "containedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (2.0, 2.0), infsup (0.0, 3.0)), ...
%!    "containedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (2.0, 2.0), infsup (0.0, inf)), ...
%!    "containedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 2.0), infsup (-inf, 2.0)), ...
%!    "finishes")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 2.0), infsup (0.0, 2.0)), ...
%!    "finishes")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (2.0, 2.0), infsup (0.0, 2.0)), ...
%!    "finishes")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 2.0), infsup (1.0, 2.0)), ...
%!    "equals")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 1.0), infsup (1.0, 1.0)), ...
%!    "equals")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (-inf, 1.0), infsup (-inf, 1.0)), ...
%!    "equals")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (-inf, inf), infsup (-inf, inf)), ...
%!    "equals")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (3.0, 4.0), infsup (2.0, 2.0)), ...
%!    "after")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (3.0, 4.0), infsup (1.0, 2.0)), ...
%!    "after")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (3.0, 3.0), infsup (1.0, 2.0)), ...
%!    "after")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (3.0, 3.0), infsup (2.0, 2.0)), ...
%!    "after")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (3.0, inf), infsup (2.0, 2.0)), ...
%!    "after")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (2.0, 3.0), infsup (1.0, 2.0)), ...
%!    "metBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (2.0, 3.0), infsup (-inf, 2.0)), ...
%!    "metBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.5, 2.5), infsup (1.0, 2.0)), ...
%!    "overlappedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.5, 2.5), infsup (-inf, 2.0)), ...
%!    "overlappedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, inf), infsup (1.0, 2.0)), ...
%!    "startedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 3.0), infsup (1.0, 2.0)), ...
%!    "startedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (1.0, 3.0), infsup (1.0, 1.0)), ...
%!    "startedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (-inf, 3.0), infsup (1.0, 2.0)), ...
%!    "contains")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (-inf, inf), infsup (1.0, 2.0)), ...
%!    "contains")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (0.0, 3.0), infsup (1.0, 2.0)), ...
%!    "contains")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (0.0, 3.0), infsup (2.0, 2.0)), ...
%!    "contains")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (-inf, 2.0), infsup (1.0, 2.0)), ...
%!    "finishedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (0.0, 2.0), infsup (1.0, 2.0)), ...
%!    "finishedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsup (0.0, 2.0), infsup (2.0, 2.0)), ...
%!    "finishedBy")))

## minimal_overlap_dec_test

%!test
%! assert (all (eq (...
%!    overlap (infsupdec (empty, "trv"), infsupdec (empty, "trv")), ...
%!    "bothEmpty")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (empty, "trv"), infsupdec (1.0, 2.0, "com")), ...
%!    "firstEmpty")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (1.0, 2.0, "def"), infsupdec (empty, "trv")), ...
%!    "secondEmpty")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (2.0, 2.0, "def"), infsupdec (3.0, 4.0, "def")), ...
%!    "before")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (1.0, 2.0, "dac"), infsupdec (3.0, 4.0, "com")), ...
%!    "before")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (1.0, 2.0, "com"), infsupdec (3.0, 3.0, "trv")), ...
%!    "before")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (2.0, 2.0, "trv"), infsupdec (3.0, 3.0, "def")), ...
%!    "before")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (1.0, 2.0, "def"), infsupdec (2.0, 3.0, "def")), ...
%!    "meets")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (1.0, 2.0, "dac"), infsupdec (1.5, 2.5, "def")), ...
%!    "overlaps")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (1.0, 2.0, "def"), infsupdec (1.0, 3.0, "com")), ...
%!    "starts")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (1.0, 1.0, "trv"), infsupdec (1.0, 3.0, "def")), ...
%!    "starts")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (1.0, 2.0, "def"), infsupdec (0.0, 3.0, "dac")), ...
%!    "containedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (2.0, 2.0, "trv"), infsupdec (0.0, 3.0, "def")), ...
%!    "containedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (1.0, 2.0, "trv"), infsupdec (0.0, 2.0, "com")), ...
%!    "finishes")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (2.0, 2.0, "def"), infsupdec (0.0, 2.0, "dac")), ...
%!    "finishes")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (1.0, 2.0, "def"), infsupdec (1.0, 2.0, "def")), ...
%!    "equals")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (1.0, 1.0, "dac"), infsupdec (1.0, 1.0, "dac")), ...
%!    "equals")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (3.0, 4.0, "trv"), infsupdec (2.0, 2.0, "trv")), ...
%!    "after")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (3.0, 4.0, "def"), infsupdec (1.0, 2.0, "def")), ...
%!    "after")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (3.0, 3.0, "com"), infsupdec (1.0, 2.0, "dac")), ...
%!    "after")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (3.0, 3.0, "def"), infsupdec (2.0, 2.0, "trv")), ...
%!    "after")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (2.0, 3.0, "def"), infsupdec (1.0, 2.0, "trv")), ...
%!    "metBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (1.5, 2.5, "com"), infsupdec (1.0, 2.0, "com")), ...
%!    "overlappedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (1.0, 3.0, "dac"), infsupdec (1.0, 2.0, "def")), ...
%!    "startedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (1.0, 3.0, "com"), infsupdec (1.0, 1.0, "dac")), ...
%!    "startedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (0.0, 3.0, "com"), infsupdec (1.0, 2.0, "dac")), ...
%!    "contains")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (0.0, 3.0, "com"), infsupdec (2.0, 2.0, "def")), ...
%!    "contains")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (0.0, 2.0, "def"), infsupdec (1.0, 2.0, "trv")), ...
%!    "finishedBy")))
%!test
%! assert (all (eq (...
%!    overlap (infsupdec (0.0, 2.0, "dac"), infsupdec (2.0, 2.0, "def")), ...
%!    "finishedBy")))
